SystemOrganization addCategory: #'SBE-Quinto'!

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell commentStamp: 'emc 8/26/2012 09:17' prior: 0!
Cell in Quinto game!

!SBECell methodsFor: 'initialization' stamp: 'emc 8/26/2012 09:18'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff
! !

!SBECell methodsFor: 'accessing' stamp: 'emc 8/26/2012 09:50'!
mouseAction: aBlock
^ mouseAction := aBlock
! !

!SBECell methodsFor: 'event handling' stamp: 'emc 8/26/2012 09:53'!
mouseUp: anEvent
mouseAction value
! !

BorderedMorph subclass: #SBEGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame methodsFor: 'initialization' stamp: 'emc 8/26/2012 09:42'!
cellsPerSide
"The number of cells along each side of the game"
^ 10
! !

!SBEGame methodsFor: 'initialization' stamp: 'emc 8/26/2012 10:17'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	self
		bounds: (50 @ 50 extent: width * n @ (height * n) + (2 * self borderWidth)).
	cells := Matrix
				new: n
				tabulate: [:i :j | self newCellAt: i at: j]! !

!SBEGame methodsFor: 'initialization' stamp: 'emc 8/26/2012 12:01'!
newCellAt: i at: j 
	"Create a cell for position (i,j) and add it to my on--screen
	representation at the appropriate screen position. Answer the new cell"
	| c origin |
	c := SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: i - 1 * c width @ (j - 1 * c height) + origin.
		c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
		^c! !

!SBEGame methodsFor: 'game logic' stamp: 'emc 8/26/2012 09:46'!
toggleNeighboursOfCellAt: i at: j 
	i > 1
		ifTrue: [(cells at: i - 1 at: j) toggleState].
	i < self cellsPerSide
		ifTrue: [(cells at: i + 1 at: j) toggleState].
	j > 1
		ifTrue: [(cells at: i at: j - 1) toggleState].
	j < self cellsPerSide
		ifTrue: [(cells at: i at: j + 1) toggleState]! !
